# $Id: calendar.rb,v 1.8 2003/08/21 12:38:37 not Exp $

=begin

  calendar.rb

    nDiary Plug-in  J_[̍쐬

    etւ̃Nt̃J_[쐬܂B

    option:
      lang=en         Atp\Lɂ܂B(Sun, Mon, ...)
      lang=en2        Atp\Lɂ܂B(Su,  Mo,  ...)

      exsample:
        <!--plug=calendar?lang=en-->

=end


def plug(opt)
  require 'date'

  begin
    require 'date/holiday'
    holiday_flag = true
  rescue LoadError
    holiday_flag = false
  end

  if self.kind_of?(LastDiary) or self.kind_of?(Topics) then
    thismonth = @diaries[0][0..5]
  elsif self.kind_of?(PastDiary) then
    thismonth = @targetMonth
  else
    return
  end

  y = thismonth[0..3].to_i
  m = thismonth[4..5].to_i


  if m  == 12 then
    nextmonth = sprintf("%04d01", y + 1)
  else
    nextmonth = sprintf("%04d%02d", y, m + 1)
  end

  if m  == 1 then
    prevmonth = sprintf("%04d12", y - 1)
  else
    prevmonth = sprintf("%04d%02d", y, m - 1)
  end

  monthlink     = date2monthlyfilelink(thismonth)
  nextmonthlink = date2monthlyfilelink(nextmonth)
  prevmonthlink = date2monthlyfilelink(prevmonth)
  nextmonthlink = %Q!<a href="#{nextmonthlink}">&gt;&gt;</a>! unless nextmonthlink.empty?
  prevmonthlink = %Q!<a href="#{prevmonthlink}">&lt;&lt;</a>! unless prevmonthlink.empty?

  if opt['lang'] == 'en' then
    wdayname = %w(Sun Mon Tue Wed Thu Fri Sat)
    mo  = Time::local(y,m).strftime("%Y/%m")
  elsif opt['lang'] == 'en2' then
    wdayname = %w(Su Mo Tu We Th Fr Sa)
    mo  = Time::local(y,m).strftime("%Y-%m")
  else
    wdayname = %w(      y)
    mo  = Time::local(y,m).strftime2("%YN%m")
  end

  css = %w(sunday monday tuesday wedneday thursday friday saturday)

  topic = {}
  begin
    open(@logDirectory + thismonth + '.topic'){ |f|
      f.each{ |line|
        d, t = line.split(/\t/,2)
        t.gsub!(/\t/, "&#10;")
        topic[d[6..7].to_i] = %!title="#{t.chomp}"!
      }
    }
  rescue
    #
  end

  day = (1..28).to_a.concat((29..31).to_a.delete_if{ |d|
    begin
      !Date::valid_date?(y, m, d)
    rescue NameError
      !Date::exist?(y, m, d)
    end
  }).collect!{ |d|
    d.to_s
  }

  1.upto(Time::local(y,m,1).wday){
    day.unshift(" ")
  }

  5.downto(Time::local(y,m,day[-1]).wday){
    day.push(" ")
  }
  
  str = %Q!<div class="calendar"><table class="calendar">\n!

  str << <<HTML_END
	<tr>
    <th colspan="2">#{prevmonthlink}</th>
    <th colspan="3"><a href="#{monthlink}">#{mo}</a></th>
    <th colspan="2">#{nextmonthlink}</th>
	</tr>
HTML_END

  str << "\t<tr>\n"
  for i in 0..6
    str << %Q!\t\t<th class="#{css[i]}">#{wdayname[i]}</th>\n!
  end
  str << "\t</tr>\n"

  while day.size != 0
    str << "\t<tr>\n"
    for i in 0..6
      d = day.shift
      dd = sprintf("%02d", d.to_i)
      c = css[i]
      if holiday_flag and d != ' ' and Date::new(y,m,d.to_i).national_holiday? then
        c = 'holiday'
      end
      if @allDiaries.key?(thismonth + dd) then
        link = date2monthlyfilelink(thismonth + dd, true)
        str << %Q!\t\t<td class="#{c}"><a href="#{link}" #{topic[d.to_i]}>#{d}</a></td>\n!
      else
        str << %Q!\t\t<td class="#{c}">#{d}</td>\n!
      end
    end
    str << "\t</tr>\n"
  end
  str << "</table></div>\n"

  return str

end
